IFNDEF __ASMLIB__
__ASMLIB__ EQU 100; v1.00
IFNDEF AL_ALIAS
AL_ALIAS EQU 1
ENDIF
;;
;; ASMLIB : MACROS
;;
include asmlib.mac
;;
;; ASMLIB : REGISTRY
;;
RegKeyClose proto stdcall 
RegKeyOpen proto stdcall :dword,:dword,:dword
RegKeyDelete EQU <RegDeleteKey>
RegReadDw proto stdcall :dword
RegReadStr proto stdcall :dword,:dword,:dword
RegWriteDw proto stdcall :dword,:dword
RegWriteStr proto stdcall :dword,:dword

Reg macro func:req, args:vararg
	funcx SubStr <func>,2
	ifb <args> 
	%invoke Reg&funcx
	else
	%invoke Reg&funcx, args
	endif
endm

;;
;; ASMLIB : INI FILES
;;
IniSetFileName proto stdcall pFileName:dword
IniSetSection proto stdcall pSection:dword
IniReadDword proto stdcall pKey:dword, dwDefault:dword
IniReadInt proto stdcall pKey:dword, IntDefault:dword
IniReadStr proto stdcall pKey:dword, pBuffer:dword, BufSize:dword
IniReadStruct proto stdcall pKey:dword, pStruct:dword, nSize:dword
IniWriteDword proto stdcall pKey:dword, dwValue:dword
IniWriteInt proto stdcall pKey:dword, IntValue:dword
IniWriteStr proto stdcall pKey:dword, pString:dword
IniWriteStruct proto stdcall pKey:dword, pStruct:dword, nSize:dword
;;
;; ASMLIB : FILES
;;
FileClose proto stdcall hFile:DWORD
FileCreate proto stdcall pszFileName:DWORD
FileDelete proto stdcall pszFileName:DWORD
FileExists proto stdcall pszFileName:DWORD
FileOpen proto stdcall pszFileName:DWORD,dwMode:DWORD
FileRead proto stdcall hFile:DWORD,pBuffer:DWORD,dwCount:DWORD
FileSeek proto stdcall hFile:DWORD,dwOffset:DWORD,dwOrigin:DWORD
FileSize proto stdcall hFile:DWORD
FileWrite proto stdcall hFile:DWORD,pBuffer:DWORD,dwCount:DWORD

File macro func:req, args:vararg
	funcx SubStr <func>,2
	ifb <args> 
	%invoke File&funcx
	else
	%invoke File&funcx, args
	endif
endm

;;
;; ASMLIB : CONVERT PROCS
;;
BinaryToDword proto stdcall pszbinstr:DWORD
DwordToBinary proto stdcall dwValue:dword,pBuffer:dword;buff max 33bytes
BitCount proto stdcall dwValue:DWORD
ByteToHex proto stdcall dwByte:DWORD
DwordToHex proto stdcall dwValue:DWORD,pBuffer:DWORD
DwordToString proto stdcall dwValue:DWORD,pBuffer:DWORD
DwordToStringl proto stdcall dwValue:DWORD,pBuffer:DWORD
HexToDword proto stdcall pString:DWORD
Int64ToString proto stdcall QwValue:QWORD,pBuffer:DWORD
IntToString proto stdcall dwValue:DWORD,pBuffer:DWORD
QwordToHex proto stdcall pQwValue:DWORD,pBuffer:DWORD
StringToDword proto stdcall pDwString:DWORD
StringToInt proto stdcall pIntStr:DWORD
StringToInt64 proto stdcall pInt64Str:DWORD
StringToUInt64 proto stdcall pQwString:DWORD
Time1970ToSystemTime proto stdcall __time_t:dword, __systemtime:dword
SystemTimeToTime1970 proto stdcall __systemtime:DWORD
UInt64ToString proto stdcall QwVal:QWORD, pszString:DWORD

Cvt macro srcA:req, dstB:req, args:vararg
	funcx SubStr <func>,2
	ifb <args> 
	%invoke srcA&To&srcB
	else
	%invoke srcA&To&srcB, args
	endif
endm

;;
;; ASMLIB : CONSOLE FUNCTIONS
;;
;++
; @enum CONSOLE color :: 0..15
;++
@Enum 0,ccBlack,ccBlue,ccGreen,ccCyan,ccRed,ccMagenta,ccBrown,ccLightGray,ccDarkGray,ccLightBlue
@Enum ccLightBlue+1,ccLightGreen,ccLightCyan,ccLightRed,ccLightMagenta,ccYellow,ccWhite
;-
ConsoleInit proto stdcall
ConsoleWrite proto stdcall lpBuffer:dword
ConsoleWriteLine proto stdcall lpBuffer:dword
ConsoleClear proto stdcall
ConsoleFullScreen proto stdcall
ConsoleGoto proto stdcall coordX:sdword,coordY:sdword
ConsoleGetChar proto stdcall
ConsolePutChar proto stdcall Char:DWORD
ConsoleLocate proto stdcall
ConsoleReadLine proto stdcall lpText:dword, lpBuffer:DWORD, BufLen:DWORD
ConsoleTextColor proto stdcall Color:dword
ConsoleBackColor proto stdcall Color:dword
ConsoleWriteLinef proto c pFormat:dword, vargs:VARARG

Con macro func:req, args:vararg
	funcx SubStr <func>,2
	ifb <args> 
	%invoke Console&funcx
	else
	%invoke Console&funcx, args
	endif
endm
;;
;; ASMLIB : STRING FUNCTIONS
;;
CHR_UPPER equ 00000001b
CHR_LOWER equ 00000010b
CHR_DIGIT equ 00000100b
CHR_DELIM equ 00001000b
CHR_PUNCT equ 00010000b
CHR_CNTRL equ 00100000b
CHR_SPACE equ 01000000b
CHR_HEX   equ 10000000b
CHR_ALPHA equ CHR_LOWER or CHR_UPPER
CHR_ALNUM equ CHR_LOWER or CHR_UPPER or CHR_DIGIT
CHR_PRINT equ CHR_LOWER or CHR_UPPER or CHR_DIGIT or CHR_PUNCT or CHR_SPACE
;-
CR   textequ <13>
LF   textequ <10>
CRLF textequ <CR,LF>
;-
CharTest proto stdcall ChrByte:DWORD,ChrFlags:DWORD
StringLength proto stdcall lpString:dword
StringCopy proto stdcall pStrDest:dword,pStrSource:dword
StringConcat proto stdcall pStrDest:dword,pStrSource:dword
StringCompareI proto stdcall pStr1:DWORD,pStr2:DWORD
StringCompare proto stdcall pStr1:DWORD,pStr2:DWORD
StringChar proto stdcall pStr:DWORD,ByteChr:DWORD
StringCharRight proto stdcall pStr:DWORD,ByteChr:DWORD
StringEnd proto stdcall pStr:DWORD
StringLower proto stdcall pStr:dword
StringMultiConcat proto C pStr:DWORD,StrArray:VARARG
StringNCompare proto stdcall pStr1:DWORD,pStr2:DWORD,dwCount:DWORD;case sensitive
StringNCompareI proto stdcall pStr1:DWORD,pStr2:DWORD,dwCount:DWORD
StringNConcat proto stdcall pStrDest:DWORD,pStrSource:DWORD,dwCount:DWORD
StringNCopy proto stdcall pStrDest:DWORD,pStrSource:DWORD,dwCount:DWORD
StringPosition proto stdcall pStrBuff:DWORD,pSubStr:DWORD
StringReverse proto stdcall pStr:DWORD
StringSet proto stdcall pStr:DWORD,ByteChr:DWORD
StringTokenize proto stdcall pszStr:DWORD,pszDelimChars:DWORD
StringTrim proto stdcall pszStr:DWORD,pszTrimChars:DWORD
StringTrimLeft proto stdcall pszStr:DWORD,pszTrimChars:DWORD
StringTrimRight proto stdcall pszStr:DWORD,pszTrimChars:DWORD
StringUpper proto stdcall pStr:DWORD

option nokeyword:<Str>
Str macro func:req, args:vararg
	funcx SubStr <func>,2
	ifb <args> 
	%invoke String&funcx
	else
	%invoke String&funcx, args
	endif
endm
;;
;; ASMLIB : MEMORY FUNCTIONS
;;
MemoryCompare proto stdcall pDest:dword, pSrc:dword, dwCount:dword
MemoryZero proto stdcall pDest:dword, dwCount:dword
MemoryFill proto stdcall pDest:dword, dwCount:dword, dwChar:dword
MemoryCopy proto stdcall pDest:dword, pSrc:dword, dwCount:dword
MemoryAlloc proto stdcall dwBytes:dword
MemoryFree proto stdcall lpMem:dword
MemoryBigAlloc proto stdcall dwBytes:dword
MemoryBigFree proto stdcall lpMem:dword
MemoryResize proto stdcall lpMem:dword,dwNewBytes:dword
;;
;; ASMLIB : GENERAL/OTHER FUNCTIONS
;;
pushad_size equ 8*4
pushad_eax  equ 7*4
pushad_ecx  equ 6*4
pushad_edx  equ 5*4
pushad_ebx  equ 4*4
pushad_esp  equ 3*4
pushad_ebp  equ 2*4
pushad_esi  equ 1*4
pushad_edi  equ 0*4
;-
PUSHAD_ struct
	edi_ dd ?
	esi_ dd ?
	ebp_ dd ?
	esp_ dd ?
	ebx_ dd ?
	edx_ dd ?
	ecx_ dd ?
	eax_ dd ?
PUSHAD_ ends
;-
Random proto stdcall Range:DWORD
Randomize proto stdcall

ExtractFileName proto stdcall pFileName:dword,pBuffer:dword
ExtractFilePath proto stdcall pFileName:dword,pBuffer:dword

;;
;; ASMLIB : U64/INT64 SUPPORT FUNCTIONS
;;
UInt64_t STRUCT
	Union
	Lo DWORD ?
	Hi DWORD ?
	Ends
	QWORD ?
UInt64_t ENDS
UInt64 typedef UInt64_t
;-
Int64_t STRUCT
	Union
	Lo DWORD ?
	Hi SDWORD ?
	Ends
	QWORD ?
Int64_t ENDS
Int64 typedef Int64_t
;-
UInt64Inc proto stdcall ull:qword
UInt64Dec proto stdcall ull:qword
UInt64Neg proto stdcall ull:qword
UInt64Not proto stdcall ull:qword
UInt64Add proto stdcall ull1:qword, ull2:qword
UInt64Sub proto stdcall ull1:qword, ull2:qword
UInt64Shl proto stdcall ull1:qword, cnt:dword
UInt64Shr proto stdcall ull1:qword, cnt:dword
UInt64Rol proto stdcall ull1:qword, cnt:dword
UInt64Ror proto stdcall ull1:qword, cnt:dword
UInt64Mul proto stdcall ull1:qword, ull2:qword
UInt64Div proto stdcall ull1:qword, ull2:qword
UInt64Rem proto stdcall ull1:qword, ull2:qword
Int64Mul proto stdcall ull1:qword, ull2:qword
Int64Div proto stdcall ull1:qword, ull2:qword
Int64Rem proto stdcall ull1:qword, ull2:qword
Int64Shr proto stdcall ull1:qword, cnt:dword


;;
;; ASMLIB : ALIAS NAMES
;;
IF AL_ALIAS EQ 1
BinToDw equ <BinaryToDword>
DwToBin equ <DwordToBinary>
DwToHex equ <DwordToHex>
DwToStr equ <DwordToString>
DwToStrl equ <DwordToStringl>
HexToDw equ <HexToDword>
Int64ToStr equ <Int64ToString>
IntToStr equ <IntToString>
QwToHex equ <QwordToHex>
StrToDw equ <StringToDword>
StrToInt equ <StringToInt>
StrToInt64 equ <StringToInt64>
StrToU64 equ <StringToUInt64>
U64ToStr equ <UInt64ToString>

U64Inc equ <UInt64Inc>
U64Dec equ <UInt64Dec>
U64Neg equ <UInt64Neg>
U64Not equ <UInt64Not>
U64Add equ <UInt64Add>
U64Sub equ <UInt64Sub>
U64Shl equ <UInt64Shl>
U64Shr equ <UInt64Shr>
U64Rol equ <UInt64Rol>
U64Ror equ <UInt64Ror>
U64Mul equ <UInt64Mul>
U64Div equ <UInt64Div>
U64Rem equ <UInt64Rem>

ChrTest equ <CharTest>
StrLen equ <StringLength>
StrCpy equ <StringCopy>
StrCat equ <StringConcat>
StrCmpI equ <StringCompareI>
StrCmp equ <StringCompare>
StrChr equ <StringChar>
StrRChr equ <StringCharRight>
StrEnd equ <StringEnd>
StrLwr equ <StringLower>
StrMCat equ <StringMultiConcat>
StrNCmp equ <StringNCompare>
StrNCmpI equ <StringNCompareI>
StrNCat equ <StringNConcat>
StrNCpy equ <StringNCopy>
StrPos equ <StringPosition>
StrRev equ <StringReverse>
StrSet equ <StringSet>
StrTok equ <StringTokenize>
StrTrim equ <StringTrim>
StrLTrim equ <StringTrimLeft>
StrRTrim equ <StringTrimRight>
StrUpr equ <StringUpper>

ConInit equ <ConsoleInit>
ConWrite equ <ConsoleWrite>
ConWriteln equ <ConsoleWriteLine>
ConClear equ <ConsoleClear>
ConFullScreen equ <ConsoleFullScreen>
ConGoto equ <ConsoleGoto>
ConGetc equ <ConsoleGetChar>
ConPutc equ <ConsolePutChar>
ConLocate equ <ConsoleLocate>
ConReadln equ <ConsoleReadLine>
ConTextColor equ <ConsoleTextColor>
ConBackColor equ <ConsoleBackColor>
ConWritelnf equ <ConsoleWriteLinef>

MemCmp equ <MemoryCompare>
MemZero equ <MemoryZero>
MemFill equ <MemoryFill>
MemCpy equ <MemoryCopy>
MemAlloc equ <MemoryAlloc>
MemFree equ <MemoryFree>
MemVAlloc equ <MemoryBigAlloc>
MemVFree equ <MemoryBigFree>
MemResize equ <MemoryResize>

ENDIF
;-
ENDIF;;__ASMLIB__
